// author: Kwang-Hyun Park (akaii@kw.ac.kr)

#include <windows.h>
#include "library.h"

HINSTANCE hamster_hinstance;

void hamster_load_library(void) {
	hamster_hinstance = LoadLibrary("hamster.dll");

	HMODULE hmodule = (HMODULE)hamster_hinstance;
	if(hmodule == NULL) return;

	hamster_dispose_all = (HAMSTER_DISPOSE_ALL)GetProcAddress(hmodule, "hamster_dispose_all");
	hamster_wait = (HAMSTER_WAIT)GetProcAddress(hmodule, "hamster_wait");
	
	hamster_create = (HAMSTER_CREATE)GetProcAddress(hmodule, "hamster_create");
	hamster_get_name = (HAMSTER_GET_NAME)GetProcAddress(hmodule, "hamster_get_name");
	hamster_set_name = (HAMSTER_SET_NAME)GetProcAddress(hmodule, "hamster_set_name");
	hamster_get_port_name = (HAMSTER_GET_PORT_NAME)GetProcAddress(hmodule, "hamster_get_port_name");
	hamster_get_address = (HAMSTER_GET_ADDRESS)GetProcAddress(hmodule, "hamster_get_address");
	hamster_e = (HAMSTER_E)GetProcAddress(hmodule, "hamster_e");
	hamster_read = (HAMSTER_READ)GetProcAddress(hmodule, "hamster_read");
	hamster_read_at = (HAMSTER_READ_AT)GetProcAddress(hmodule, "hamster_read_at");
	hamster_read_array = (HAMSTER_READ_ARRAY)GetProcAddress(hmodule, "hamster_read_array");
	hamster_read_float = (HAMSTER_READ_FLOAT)GetProcAddress(hmodule, "hamster_read_float");
	hamster_read_float_at = (HAMSTER_READ_FLOAT_AT)GetProcAddress(hmodule, "hamster_read_float_at");
	hamster_read_float_array = (HAMSTER_READ_FLOAT_ARRAY)GetProcAddress(hmodule, "hamster_read_float_array");
	hamster_write = (HAMSTER_WRITE)GetProcAddress(hmodule, "hamster_write");
	hamster_write_at = (HAMSTER_WRITE_AT)GetProcAddress(hmodule, "hamster_write_at");
	hamster_write_array = (HAMSTER_WRITE_ARRAY)GetProcAddress(hmodule, "hamster_write_array");
	hamster_write_float = (HAMSTER_WRITE_FLOAT)GetProcAddress(hmodule, "hamster_write_float");
	hamster_write_float_at = (HAMSTER_WRITE_FLOAT_AT)GetProcAddress(hmodule, "hamster_write_float_at");
	hamster_write_float_array = (HAMSTER_WRITE_FLOAT_ARRAY)GetProcAddress(hmodule, "hamster_write_float_array");
	hamster_reset = (HAMSTER_RESET)GetProcAddress(hmodule, "hamster_reset");
	hamster_set_executable = (HAMSTER_SET_EXECUTABLE)GetProcAddress(hmodule, "hamster_set_executable");
	
	hamster_create_multi = (HAMSTER_CREATE_MULTI)GetProcAddress(hmodule, "hamster_create_multi");
	hamster_get_name_multi = (HAMSTER_GET_NAME_MULTI)GetProcAddress(hmodule, "hamster_get_name_multi");
	hamster_set_name_multi = (HAMSTER_SET_NAME_MULTI)GetProcAddress(hmodule, "hamster_set_name_multi");
	hamster_get_port_name_multi = (HAMSTER_GET_PORT_NAME_MULTI)GetProcAddress(hmodule, "hamster_get_port_name_multi");
	hamster_get_address_multi = (HAMSTER_GET_ADDRESS_MULTI)GetProcAddress(hmodule, "hamster_get_address_multi");
	hamster_e_multi = (HAMSTER_E_MULTI)GetProcAddress(hmodule, "hamster_e_multi");
	hamster_read_multi = (HAMSTER_READ_MULTI)GetProcAddress(hmodule, "hamster_read_multi");
	hamster_read_at_multi = (HAMSTER_READ_AT_MULTI)GetProcAddress(hmodule, "hamster_read_at_multi");
	hamster_read_array_multi = (HAMSTER_READ_ARRAY_MULTI)GetProcAddress(hmodule, "hamster_read_array_multi");
	hamster_read_float_multi = (HAMSTER_READ_FLOAT_MULTI)GetProcAddress(hmodule, "hamster_read_float_multi");
	hamster_read_float_at_multi = (HAMSTER_READ_FLOAT_AT_MULTI)GetProcAddress(hmodule, "hamster_read_float_at_multi");
	hamster_read_float_array_multi = (HAMSTER_READ_FLOAT_ARRAY_MULTI)GetProcAddress(hmodule, "hamster_read_float_array_multi");
	hamster_write_multi = (HAMSTER_WRITE_MULTI)GetProcAddress(hmodule, "hamster_write_multi");
	hamster_write_at_multi = (HAMSTER_WRITE_AT_MULTI)GetProcAddress(hmodule, "hamster_write_at_multi");
	hamster_write_array_multi = (HAMSTER_WRITE_ARRAY_MULTI)GetProcAddress(hmodule, "hamster_write_array_multi");
	hamster_write_float_multi = (HAMSTER_WRITE_FLOAT_MULTI)GetProcAddress(hmodule, "hamster_write_float_multi");
	hamster_write_float_at_multi = (HAMSTER_WRITE_FLOAT_AT_MULTI)GetProcAddress(hmodule, "hamster_write_float_at_multi");
	hamster_write_float_array_multi = (HAMSTER_WRITE_FLOAT_ARRAY_MULTI)GetProcAddress(hmodule, "hamster_write_float_array_multi");
	hamster_reset_multi = (HAMSTER_RESET_MULTI)GetProcAddress(hmodule, "hamster_reset_multi");
	hamster_set_executable_multi = (HAMSTER_SET_EXECUTABLE_MULTI)GetProcAddress(hmodule, "hamster_set_executable_multi");
}

void hamster_free_library(void) {
	FreeLibrary((HMODULE)hamster_hinstance);
}
